<template>
  <div class="inputRadio">
    <label
      v-for="item in list"
      :key="`radio-${name}-${item.value}`"
      class="inputRadio-item"
      v-tooltip="isMapDisabled(item.label) ? tooltip : null"
      :class="{'disabled': isMapDisabled(item.label)}">
      <input
        class="inputRadio-input"
        type="radio"
        :checked="item.value === value"
        :disabled="(item.label === 'На карте' && mapDisabled)"
        @change="$emit('input', item.value)"
        :name="`switcher-${name}`">
      <span class="inputRadio-label">{{ item.label }}</span>
    </label>
  </div>
</template>

<script>
export default {
  name: 'AppInputRadio',
  props: {
    name: {
      type: String,
      required: true,
    },
    list: {
      type: Array,
      required: true,
    },
    value: {
      type: [String, Number, Boolean],
      default: null,
    },
    mapDisabled: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      tooltip: {
        content: 'Выберите город, чтобы посмотреть <br>предложения на карте',
        classes: 'tooltip tooltipDark',
        placement: 'bottom',
        trigger: 'hover',
        offset: 4,
        delay: 0,
      },
    };
  },
  methods: {
    isMapDisabled(label) {
      return (label === 'На карте' && this.mapDisabled);
    },
  },
};
</script>

<style lang="postcss">
  .inputRadio {
    display: flex;
    justify-content: space-between;
    height: var(--btn-height-regular);

    &-item {
      display: inline-flex;
      height: 100%;

      &:after {
        content: '';
        height: 100%;
        border-right: var(--form-switch-border);
      }

      &:first-of-type {
        .inputRadio-label {
          // padding-left: 0.875rem;
          border-top-left-radius: 0.25rem;
          border-bottom-left-radius: 0.25rem;
          border-left: var(--form-switch-border);
        }
      }

      &:last-of-type {
        &:after {
          content: none;
        }

        .inputRadio-label {
          // padding-right: 0.875rem;
          border-top-right-radius: 0.25rem;
          border-bottom-right-radius: 0.25rem;
          border-right: var(--form-switch-border);
        }
      }

      &.disabled {
        .inputRadio-label {
          color: #cccccc;
          cursor: default;

           &:hover {
            background-color: var(--form-switch-bg);
          }
        }
      }
    }

    &-input {
      position: absolute;
      margin: 0;
      //Alex_czech Обнуляем стили для ios device
      border: none;
      background-color: transparent;
      appearance: none;
    }

    &-label {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      padding: 0 0.75rem;
      width: 100%;
      height: 100%;

      font-size: 0.75rem;
      line-height: 1.4;
      font-weight: var(--font-weight-regular);
      color: var(--color-main);
      white-space: nowrap;

      background-color: var(--form-switch-bg);
      border-top: var(--form-switch-border);
      border-bottom: var(--form-switch-border);
      cursor: pointer;

      &:hover {
        background-color: var(--form-switch-hover-bg);
      }
    }

    &-input:checked + &-label {
      background-color: var(--form-switch-active-bg);
      box-shadow: inset 0 1px 2px rgba(0, 0, 0, 0.13);
      pointer-events: none;
    }

    &._form-circle {

      .inputRadio-item {
        &:first-of-type {
          .inputRadio-label {
            border-top-left-radius: 2.5rem;
            border-bottom-left-radius: 2.5rem;
          }
        }

        &:last-of-type {
          .inputRadio-label {
            border-top-right-radius: 2.5rem;
            border-bottom-right-radius: 2.5rem;
          }
        }
      }

      .inputRadio-label {
        padding: 0 1.375rem;
      }
    }

    @media screen and (min-width: 1201px) {
      &._form-circle {
        height: 1.875rem;

        .inputRadio-item {

          &:first-of-type {
            .inputRadio-label {
              padding-left: 1.5rem;
            }
          }

          &:last-of-type {
            .inputRadio-label {
              padding-right: 1.5rem;
            }
          }
        }
      }

      &._filter {
        height: 1.75rem;
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      height: var(--btn-height-medium);

      &._filter {
        height: var(--btn-height-regular);
      }

      &._form-circle {
        .inputRadio-label {
          padding: 0 2.25rem;
          font-size: 0.875rem;
        }
      }
    }

    @media screen and (max-width: 980px) {
      width: 100%;
      height: var(--btn-height-huge);

      &-item {
        width: 100%;
      }
      &-label {
        padding: 0 .375rem;
        white-space: normal;
        font-size: 0.875rem;
        text-align: center;
      }

      &._form-circle {
        .inputRadio-label {
          padding: 0 1rem;
        }
      }
    }
  }
</style>
